﻿/*
Artwork.js
(c) 2007 Chris Mrazek
*/

function ArtworkClick()
{
	try
	{
		if (iTunes != null && iTunes.CurrentTrack != null)
		{
			if (setting_DownloadArtworkOnClick)
			{
				if (setting_ClickArtworkReplaces || !g_gotArtwork)
				{
					DoArtworkDownload();
				}
				else if (g_gotArtwork)
				{
					ExpandCurrentArtwork();
				}
			}
			else if (g_gotArtwork)
			{
				ExpandCurrentArtwork();
			}
		}
	}
	catch(ex)
	{
		EventLogEx(LogError, ex, "Exception when user clicked on artwork.");
	}
}

function ExpandCurrentArtwork()
{
	if (g_gotArtwork && g_artworkLoc != "")
	{
		var item = System.Shell.itemFromPath(g_artworkLoc);
		if (item != null)
		{
			item.invokeVerb();
		}
	}
}

function DoArtworkDownload()
{
	if (iTunes == null) return false;
	
	var currentTrack = iTunes.CurrentTrack;
	if (currentTrack == null) return false;
	
	var artist = String(currentTrack.Artist);
	var album = String(currentTrack.Album);
	if (artist == "" || album == "") return false;
	
	var imageUrl = GetAlbumImageUrl(artist, album);
	if (imageUrl == "") return false;
	
	var fileLoc = SaveImageFromUrl(imageUrl);
	if (fileLoc == "") return false;
	
	currentTrack.AddArtworkFromFile(fileLoc);
	DisplayArtwork(fileLoc);
	UpdateTrackInfo(true);
}

function GetAlbumImageUrl(artist, album)
{
	try
	{
		var requestUrl = "http://webservices.amazon.com/onca/xml"
		requestUrl += "?Service=AWSECommerceService";
		requestUrl += "&SubscriptionId=17MH5YBNZ1JDD53VYAG2";
		requestUrl += "&Operation=ItemSearch";
		requestUrl += "&Artist=" + escape(artist);
		requestUrl += "&Title=" + escape(album);
		requestUrl += "&SearchIndex=Music";
		requestUrl += "&ResponseGroup=Images";

		var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
		xmlDoc.async = false;
		if (!xmlDoc.load(requestUrl))
		{
			return "";
		}
		
		var items = xmlDoc.getElementsByTagName("Item");
		if (items.length > 0)
		{
			var item = items[0];
			
			var images = item.getElementsByTagName("LargeImage");
			if (images.length == 0) images = item.getElementsByTagName("MediumImage");
			if (images.length == 0) images = item.getElementsByTagName("SmallImage");
			
			if (images.length > 0)
			{
				var urls = images[0].getElementsByTagName("URL");
				if (urls.length > 0)
				{
					return String(urls[0].text);
				}
			}
		}
		
		return "";
	}
	catch(ex)
	{
		EventLogEx(LogWarning, ex, "Exception during Amazon.com query.");
		return "";
	}
}

function SaveImageFromUrl(url)
{
	var saveFilePathName = "";
	var req;
	
	try
	{
		req = new ActiveXObject("WinHttp.WinHttpRequest.5.1");
		req.Open("GET", url, false);
		req.Send();
	}
	catch(ex)
	{
		EventLogEx(LogWarning, ex, "Failed to download image.\nImage URL: " + url);
		return "";
	}
	
	try
	{
		var contentType = req.GetResponseHeader("Content-Type");
		if (contentType == "image/jpeg" || contentType == "image/jpg")
		{
			saveFilePathName = String(System.Gadget.path) + "\\DownloadedArtwork.jpg";
		}
		else if (contentType == "image/png")
		{
			saveFilePathName = String(System.Gadget.path) + "\\DownloadedArtwork.png";
		}
		else if (contentType == "image/bmp")
		{
			saveFilePathName = String(System.Gadget.path) + "\\DownloadedArtwork.bmp";
		}
		
		if (saveFilePathName == "")
		{
			EventLog(LogWarning, "Unrecognized content-type for artwork: " + contentType);
			return "";
		}
		
		// Can't use File.Write() because it craps out on the binary data
		var file = fso.CreateTextFile(saveFilePathName, true);
		
		var	rs = new ActiveXObject("ADODB.Recordset");
		rs.Fields.Append(0,201,req.ResponseText.length);	// 201 = longvarchar

		rs.Open();
		rs.AddNew();
		rs.Fields(0).AppendChunk(req.ResponseBody);
		
		var	data = new String(rs.Fields(0));
		rs.Close();
		
		file.Write(data);
		file.Close();
	}
	catch(ex)
	{
		EventLogEx(LogError, ex, "Failed to save artwork to file.\nImage URL: " + url + "\nFile: " + saveFilePathName);
		return "";
	}
	
	return saveFilePathName;
}

function DisplayArtwork(fileLoc)
{
	if (fileLoc != "")
	{
		ChangeArtwork(fileLoc + "?" + g_noCacheID);
		g_noCacheID++;
		g_gotArtwork = true;
		g_artworkLoc = fileLoc;
	}
	else
	{
		ChangeArtwork(g_noArtworkImage);
		g_gotArtwork = false;
		g_artworkLoc = "";
	}
}

function ChangeArtwork(src)
{
	if (g_currentArtwork == src) return;
	g_currentArtwork = src;
	
	try
	{
		artwork.filters.item("DXImageTransform.Microsoft.Fade").apply();
		artwork.src = src;
		artwork.filters.item("DXImageTransform.Microsoft.Fade").play();
	}
	catch(ex)
	{
		artwork.src = src;
	}
}
